diff -uNr mythtv-0.21/libs/libs-targetfix.pro mythtv/libs/libs-targetfix.pro
--- mythtv-0.21/libs/libs-targetfix.pro	1970-01-01 01:00:00.000000000 +0100
+++ mythtv/libs/libs-targetfix.pro	2008-06-04 06:05:51.000000000 +0200
@@ -0,0 +1,20 @@
+# Common project modifications to change the generated target.
+
+mingw {
+    dll : contains( TEMPLATE, lib ) {
+
+        # Qt under Linux/UnixMac OS X builds libBlah.a and libBlah.so,
+        # but is using the Windows defaults  libBlah.a and    Blah.so.
+        #
+        # So that our dependency targets work between SUBDIRS, override:
+        #
+        TARGET = lib$${TARGET}
+
+
+        # Windows doesn't have a nice variable like LD_LIBRARY_PATH,
+        # which means make install would be broken without extra steps.
+        # As a workaround, we store dlls with exes. Also improves debugging!
+        #
+        target.path = $${PREFIX}/bin
+    }
+}
diff -uNr mythtv-0.21/programs/mythbackend/autoexpire.cpp mythtv/programs/mythbackend/autoexpire.cpp
--- mythtv-0.21/programs/mythbackend/autoexpire.cpp	2008-02-16 00:38:50.000000000 +0100
+++ mythtv/programs/mythbackend/autoexpire.cpp	2009-04-26 09:15:09.000000000 +0200
@@ -36,7 +36,8 @@
 #include "backendutil.h"
 #include "compat.h"
 
-#define LOC QString("AutoExpire: ")
+#define LOC     QString("AutoExpire: ")
+#define LOC_ERR QString("AutoExpire Error: ")
 
 extern AutoExpire *expirer;
 
@@ -423,6 +424,26 @@
                 .arg(fsit->usedSpaceKB / 1024.0 / 1024.0, 7, 'f', 1)
                 .arg(fsit->freeSpaceKB / 1024.0 / 1024.0, 7, 'f', 1));
 
+        if ((fsit->totalSpaceKB == -1) || (fsit->usedSpaceKB == -1))
+        {
+            VERBOSE(VB_FILE, LOC_ERR + QString("fsID #%1 has invalid info, "
+                    "AutoExpire can not run for this filesystem.  "
+                    "Continuing on to next...").arg(fsit->fsID));
+            VERBOSE(VB_FILE, QString("Directories on filesystem ID %1:")
+                    .arg(fsit->fsID));
+            vector<FileSystemInfo>::iterator fsit2;
+            for (fsit2 = fsInfos.begin(); fsit2 != fsInfos.end(); fsit2++)
+            {
+                if (fsit2->fsID == fsit->fsID)
+                {
+                    VERBOSE(VB_FILE, QString("    %1:%2")
+                            .arg(fsit2->hostname).arg(fsit2->directory));
+                }
+            }
+
+            continue;
+        }
+
         if (truncateMap.contains(fsit->fsID))
         {
             VERBOSE(VB_FILE, QString(
diff -uNr mythtv-0.21/programs/mythbackend/backendutil.cpp mythtv/programs/mythbackend/backendutil.cpp
--- mythtv-0.21/programs/mythbackend/backendutil.cpp	2008-01-14 01:32:58.000000000 +0100
+++ mythtv/programs/mythbackend/backendutil.cpp	2008-12-04 06:47:51.000000000 +0100
@@ -20,24 +20,18 @@
 #include "libmyth/util.h"
 #include "libmyth/compat.h"
 
-static QMap<int, int> fsID_cache;
+static QMap<QString, int> fsID_cache;
 static QMutex cache_lock;
 
 /// gets stable fsIDs based of the dirID
-static int GetfsID(int dirID)
+static int GetfsID(vector<FileSystemInfo>::iterator fsInfo)
 {
+    QString fskey = fsInfo->hostname + ":" + fsInfo->directory;
     QMutexLocker lock(&cache_lock);
-    if (!fsID_cache.contains(dirID))
-        fsID_cache[dirID] = fsID_cache.count();
+    if (!fsID_cache.contains(fskey))
+        fsID_cache[fskey] = fsID_cache.count();
 
-    return fsID_cache[dirID];
-}
-
-// checks the cache if we know this dirID, used to skip known unique file systems
-static bool HasfsID(int dirID)
-{
-    QMutexLocker lock(&cache_lock);
-    return fsID_cache.contains(dirID);
+    return fsID_cache[fskey];
 }
 
 static size_t GetCurrentMaxBitrate(QMap<int, EncoderLink *> *encoderList)
@@ -180,7 +174,7 @@
     while (it != strlist.end())
     {
         fsInfo.hostname = *(it++);
-        fsInfo.directory = fsInfo.hostname.section(".", 0, 0) + ":" + *(it++);
+        fsInfo.directory = *(it++);
         fsInfo.isLocal = (*(it++)).toInt();
         fsInfo.fsID = (*(it++)).toInt();
         fsInfo.dirID = (*(it++)).toInt();
@@ -198,7 +192,11 @@
     for (it1 = fsInfos.begin(); it1 != fsInfos.end(); it1++)
     {
         if (it1->fsID == -1)
-            it1->fsID = GetfsID(it1->dirID);
+        {
+            it1->fsID = GetfsID(it1);
+            it1->directory =
+                it1->hostname.section(".", 0, 0) + ":" + it1->directory;
+        }
 
         it2 = it1;
         for (it2++; it2 != fsInfos.end(); it2++)
@@ -206,14 +204,14 @@
             // Sometimes the space reported for an NFS mounted dir is slightly
             // different than when it is locally mounted because of block sizes
             if (it2->fsID == -1 &&
-                (!HasfsID(it2->fsID) || it1->dirID == it2->dirID) &&
-                (absLongLong(it1->totalSpaceKB - it2->totalSpaceKB) <= 16) &&
+                (absLongLong(it1->totalSpaceKB - it2->totalSpaceKB) <= 32) &&
                 ((size_t)absLongLong(it1->usedSpaceKB - it2->usedSpaceKB)
                  <= maxWriteFiveSec))
             {
                 if (!it1->hostname.contains(it2->hostname))
                     it1->hostname = it1->hostname + "," + it2->hostname;
-                it1->directory = it1->directory + "," + it2->directory;
+                it1->directory = it1->directory + "," +
+                    it2->hostname.section(".", 0, 0) + ":" + it2->directory;
                 fsInfos.erase(it2);
                 it2 = it1;
             }
@@ -276,32 +274,56 @@
         fsInfos.push_back(fsInfo);
     }
 
+    VERBOSE(VB_SCHEDULE+VB_FILE, "Determining unique filesystems");
     size_t maxWriteFiveSec = GetCurrentMaxBitrate(tvList)/12  /*5 seconds*/;
     maxWriteFiveSec = max((size_t)2048, maxWriteFiveSec); // safety for NFS mounted dirs
     vector<FileSystemInfo>::iterator it1, it2;
     for (it1 = fsInfos.begin(); it1 != fsInfos.end(); it1++)
     {
         if (it1->fsID == -1)
-            it1->fsID = GetfsID(it1->dirID);
+            it1->fsID = GetfsID(it1);
         else
             continue;
 
+        VERBOSE(VB_SCHEDULE+VB_FILE,
+            QString("%1:%2 (fsID %3, dirID %4) using %5 out of %6 KB, "
+                    "looking for matches")
+                    .arg(it1->hostname).arg(it1->directory)
+                    .arg(it1->fsID).arg(it1->dirID)
+                    .arg(it1->usedSpaceKB).arg(it1->totalSpaceKB));
         it2 = it1;
         for (it2++; it2 != fsInfos.end(); it2++)
         {
+            VERBOSE(VB_SCHEDULE+VB_FILE,
+                QString("    Checking %1:%2 (dirID %3) using %4 of %5 KB")
+                        .arg(it2->hostname).arg(it2->directory).arg(it2->dirID)
+                        .arg(it2->usedSpaceKB).arg(it2->totalSpaceKB));
+            VERBOSE(VB_SCHEDULE+VB_FILE,
+                QString("        Total KB Diff: %1 (want <= 32)") 
+                .arg((long)absLongLong(it1->totalSpaceKB - it2->totalSpaceKB)));
+            VERBOSE(VB_SCHEDULE+VB_FILE,
+                QString("        Used  KB Diff: %1 (want <= %2)")
+                .arg((size_t)absLongLong(it1->usedSpaceKB - it2->usedSpaceKB))
+                .arg(maxWriteFiveSec));
+
             // Sometimes the space reported for an NFS mounted dir is slightly
             // different than when it is locally mounted because of block sizes
-            if (it2->fsID == -1 && !HasfsID(it2->dirID) &&
-                (absLongLong(it1->totalSpaceKB - it2->totalSpaceKB) <= 16) &&
+            if (it2->fsID == -1 &&
+                (absLongLong(it1->totalSpaceKB - it2->totalSpaceKB) <= 32) &&
                 ((size_t)absLongLong(it1->usedSpaceKB - it2->usedSpaceKB)
                  <= maxWriteFiveSec))
             {
                 it2->fsID = it1->fsID;
+
+                VERBOSE(VB_SCHEDULE+VB_FILE,
+                    QString("    MATCH Found: %1:%2 will use fsID %3")
+                            .arg(it2->hostname).arg(it2->directory)
+                            .arg(it2->fsID));
             }
         }
     }
 
-    if (print_verbose_messages & VB_FILE)
+    if (print_verbose_messages & (VB_FILE|VB_SCHEDULE))
     {
         cout << "--- GetFilesystemInfos directory list start ---" << endl;
         for (it1 = fsInfos.begin(); it1 != fsInfos.end(); it1++)
@@ -313,7 +335,8 @@
             else
                 cout << "Remote";
             cout << endl;
-            cout << "     Drive ID: " << it1->fsID << endl;
+            cout << "     fsID    : " << it1->fsID << endl;
+            cout << "     dirID   : " << it1->dirID << endl;
             cout << "     TotalKB : " << it1->totalSpaceKB << endl;
             cout << "     UsedKB  : " << it1->usedSpaceKB << endl;
             cout << "     FreeKB  : " << it1->freeSpaceKB << endl;
diff -uNr mythtv-0.21/programs/mythbackend/mainserver.cpp mythtv/programs/mythbackend/mainserver.cpp
--- mythtv-0.21/programs/mythbackend/mainserver.cpp	2008-03-03 05:47:04.000000000 +0100
+++ mythtv/programs/mythbackend/mainserver.cpp	2009-02-09 10:01:55.000000000 +0100
@@ -697,6 +697,7 @@
             }
 
             m_sched->GetNextLiveTVDir(tokens[1].toInt());
+            return;
         }
 
         if ((me->Message().left(16) == "DELETE_RECORDING") ||
@@ -1296,7 +1297,8 @@
             if (proginfo->hostname != gContext->GetHostName())
                 slave = getSlaveByHostname(proginfo->hostname);
 
-            if (proginfo->hostname == gContext->GetHostName())
+            if ((proginfo->hostname == gContext->GetHostName()) ||
+                (!slave && masterBackendOverride))
             {
                 proginfo->pathname = QString("myth://") + ip + ":" + port
                                      + "/" + proginfo->pathname;
@@ -1984,6 +1986,24 @@
             (gContext->GetNumSetting("AutoExpireInsteadOfDelete") &&
             (pginfo->recgroup != "Deleted") && (pginfo->recgroup != "LiveTV"));
 
+    QString filename = GetPlaybackURL(pginfo, false);
+    if (filename == "")
+    {
+        VERBOSE(VB_IMPORTANT,
+                QString("ERROR when trying to delete file for %1 @ %2.  Unable "
+                        "to determine filename of recording.")
+                        .arg(pginfo->chanid)
+                        .arg(pginfo->recstartts.toString(Qt::ISODate)));
+
+        if (pbssock)
+        {
+            resultCode = -2;
+            QStringList outputlist = QString::number(resultCode);
+            SendResponse(pbssock, outputlist);
+        }
+        delete pginfo;
+        return;
+    }
     
     if (justexpire && !forceMetadataDelete && pginfo->filesize > (1024 * 1024) )
     {
@@ -2001,8 +2021,6 @@
         return;
     }
 
-    QString filename = GetPlaybackURL(pginfo, false);
-
     // If this recording was made by a another recorder, and that
     // recorder is available, tell it to do the deletion.
     if (ismaster && pginfo->hostname != gContext->GetHostName())
@@ -3377,17 +3395,20 @@
     ProgramInfo *pginfo = ProgramInfo::GetProgramFromRecorded(chanid,
                                                               startdt);
 
-    if (commbreak)
-        pginfo->GetCommBreakList(markMap);
-    else
-        pginfo->GetCutList(markMap);
-
-    for (it = markMap.begin(); it != markMap.end(); ++it)
+    if (pginfo)
     {
-        rowcnt++;
-        QString intstr = QString("%1").arg(it.data());
-        retlist << intstr;
-        encodeLongLong(retlist,it.key());
+        if (commbreak)
+            pginfo->GetCommBreakList(markMap);
+        else
+            pginfo->GetCutList(markMap);
+
+        for (it = markMap.begin(); it != markMap.end(); ++it)
+        {
+            rowcnt++;
+            QString intstr = QString("%1").arg(it.data());
+            retlist << intstr;
+            encodeLongLong(retlist,it.key());
+        }
     }
 
     if (rowcnt > 0)
@@ -3449,11 +3470,12 @@
     QDateTime startdt;
     startdt.setTime_t((uint)atoi(starttime));
     QStringList retlist;
-    long long bookmark;
+    long long bookmark = 0;
 
     ProgramInfo *pginfo = ProgramInfo::GetProgramFromRecorded(chanid,
                                                               startdt);
-    bookmark = pginfo->GetBookmark();
+    if (pginfo)
+        bookmark = pginfo->GetBookmark();
 
     encodeLongLong(retlist,bookmark);
 
@@ -3491,9 +3513,14 @@
 
     ProgramInfo *pginfo = ProgramInfo::GetProgramFromRecorded(chanid,
                                                               startdt);
-    pginfo->SetBookmark(bookmark);
+    if (pginfo)
+    {
+        pginfo->SetBookmark(bookmark);
+        retlist << "OK";
+    }
+    else
+        retlist << "FAILED";
 
-    retlist << "OK";
     if (pbssock)
         SendResponse(pbssock, retlist);
 
diff -uNr mythtv-0.21/programs/mythbackend/scheduler.cpp mythtv/programs/mythbackend/scheduler.cpp
--- mythtv-0.21/programs/mythbackend/scheduler.cpp	2008-02-21 04:23:22.000000000 +0100
+++ mythtv/programs/mythbackend/scheduler.cpp	2009-04-17 23:22:38.000000000 +0200
@@ -1242,6 +1242,7 @@
         // Restore the old status for some select cases that won't record.
         if (p->recstatus != rsWillRecord && 
             p->oldrecstatus != rsUnknown &&
+            p->oldrecstatus != rsNotListed &&
             !p->reactivate)
             p->recstatus = p->oldrecstatus;
 
@@ -1303,7 +1304,7 @@
             if (next_record == nextRecMap[recid])
                 continue;
 
-            if (nextRecMap[recid].isNull() && next_record.isValid())
+            if (nextRecMap[recid].isNull() || !next_record.isValid())
             {
                 subquery.prepare("UPDATE record "
                                  "SET next_record = '0000-00-00T00:00:00' "
@@ -2030,6 +2031,13 @@
                                                      "be $time if command "
                                                      "set.\'");
 
+        if (setwakeup_cmd.isEmpty())
+        {
+            VERBOSE(VB_IMPORTANT, "SetWakeuptimeCommand is empty, shutdown aborted");
+            idleSince = QDateTime();
+            m_isShuttingDown = false;
+            return;
+        }
         if (wakeup_timeformat == "time_t")
         {
             QString time_ts;
@@ -2045,8 +2053,14 @@
                                     setwakeup_cmd);
 
         // now run the command to set the wakeup time
-        if (!setwakeup_cmd.isEmpty())
-            myth_system(setwakeup_cmd.ascii());
+        if (myth_system(setwakeup_cmd.ascii()))
+        {
+            VERBOSE(VB_IMPORTANT, "SetWakeuptimeCommand failed, "
+                    "shutdown aborted");
+            idleSince = QDateTime();
+            m_isShuttingDown = false;
+            return;
+        }
     }
 
     // tell anyone who is listening the master server is going down now
@@ -2065,7 +2079,10 @@
                                     "this computer :-\n\t\t\t\t\t\t") + halt_cmd);
 
         // and now shutdown myself
-        myth_system(halt_cmd.ascii());
+        if (!myth_system(halt_cmd.ascii()))
+            return;
+        else
+            VERBOSE(VB_IMPORTANT, "ServerHaltCommand failed, shutdown aborted");
     }
 
     // If we make it here then either the shutdown failed
@@ -2795,7 +2812,9 @@
         ProgramInfo *p = new ProgramInfo;
         p->reactivate = result.value(38).toInt();
         p->oldrecstatus = RecStatusType(result.value(37).toInt());
-        if (p->oldrecstatus == rsAborted || p->reactivate)
+        if (p->oldrecstatus == rsAborted || 
+            p->oldrecstatus == rsNotListed ||
+            p->reactivate)
             p->recstatus = rsUnknown;
         else
             p->recstatus = p->oldrecstatus;
diff -uNr mythtv-0.21/programs/mythbackend/upnpcdsvideo.cpp mythtv/programs/mythbackend/upnpcdsvideo.cpp
--- mythtv-0.21/programs/mythbackend/upnpcdsvideo.cpp	2008-03-02 22:14:41.000000000 +0100
+++ mythtv/programs/mythbackend/upnpcdsvideo.cpp	2008-03-15 18:53:54.000000000 +0100
@@ -28,7 +28,7 @@
           "1 as children "
             "FROM upnpmedia "
             "%1 "
-            "ORDER BY title DESC",
+            "ORDER BY title",
         "" }
 
 };
@@ -87,7 +87,7 @@
 {
     int nVideoID = mapParams[ "Id" ].toInt();
 
-    QString sSQL = QString( "%1 WHERE class = 'VIDEO' AND intid=:VIDEOID " )
+    QString sSQL = QString( "%1 AND intid=:VIDEOID ORDER BY title DESC" )
                                                     .arg( GetItemListSQL( ) );
 
     query.prepare( sSQL );
@@ -211,6 +211,72 @@
 
     return nCount;
 }
+
+/////////////////////////////////////////////////////////////////////////////
+//
+/////////////////////////////////////////////////////////////////////////////
+
+UPnpCDSExtensionResults *UPnpCDSVideo::ProcessItem( UPnpCDSRequest          *pRequest,
+                                                    UPnpCDSExtensionResults *pResults, 
+                                                    QStringList             &idPath )
+{
+    pResults->m_nTotalMatches   = 0;
+    pResults->m_nUpdateID       = 1;
+
+    if (pRequest->m_sObjectId.length() == 0)
+        return pResults;
+
+    QStringList tokens = QStringList::split( "/", pRequest->m_sObjectId );
+    QString     sId    = tokens.last();
+
+    if (sId.startsWith("Id"))
+        sId = sId.right( sId.length() - 2);
+
+    switch( pRequest->m_eBrowseFlag )
+    {
+        case CDS_BrowseMetadata:
+        {
+            // --------------------------------------------------------------
+            // Return 1 Item
+            // --------------------------------------------------------------
+
+            QStringMap  mapParams;
+
+            mapParams.insert( "Id", sId );
+
+            MSqlQuery query(MSqlQuery::InitCon());
+
+            if (query.isConnected())                                                           
+            {
+                BuildItemQuery( query, mapParams );
+                query.exec();
+    
+                if (query.isActive() && query.size() > 0)
+                {
+                    if ( query.next() )
+                    {
+                        AddItem( pRequest->m_sParentId, pResults, false, query );
+                        pResults->m_nTotalMatches = 1;
+                    }
+                }
+            }
+
+            break;
+        }
+
+        case CDS_BrowseDirectChildren:
+        {
+            pRequest->m_sParentId = sId;
+
+            CreateItems( pRequest, pResults, 0, "", false );
+
+            break;
+        }
+    }
+
+    return pResults;
+}
+
 /////////////////////////////////////////////////////////////////////////////
 //
 /////////////////////////////////////////////////////////////////////////////
@@ -340,25 +406,17 @@
                             .arg( sServerIp )
                             .arg( sPort     );
 
-    QString sURIParams = QString( "?Id=%1" )
-                            .arg( nVidID );
-
-    QString sId        = QString( "%1/item%2")
-                            .arg( sObjectId )
-                            .arg( sURIParams );
-
-    sURIParams = QString( "/Id%1" ).arg( nVidID );
-    sId        = QString( "%1/item%2").arg( sObjectId ).arg( sURIParams );
+    QString sURIParams = QString( "/Id%1" ).arg( nVidID );
+    QString sId        = QString( "Videos/0/item%1").arg( sURIParams );
 
     if (sParentID == QString("%1").arg(STARTING_VIDEO_OBJECTID))
     {
-        sParentID          = sObjectId;
+        sParentID = "Videos/0";
     }
     else
     {
-        sParentID          = QString( "%1/item/Id%2")
-                            .arg( sObjectId )
-                            .arg( sParentID );
+        sParentID = QString( "Videos/0/item/Id%1")
+                       .arg( sParentID );
     }
 
     QString sAlbumArtURI= QString( "%1GetVideoArt%2")
@@ -371,6 +429,8 @@
     {
         pItem   = CDSObject::CreateStorageFolder( sId, sName, sParentID);
         pItem->SetChildCount( GetCount( "parentid",QString( "%1" ).arg( nVidID )) );
+
+        pItem->SetPropValue( "storageUsed", "0" );  //-=>TODO: need proper value
     }
     else if (sItemType == "FILE" )
         pItem   = CDSObject::CreateVideoItem( sId, sName, sParentID );
diff -uNr mythtv-0.21/programs/mythbackend/upnpcdsvideo.h mythtv/programs/mythbackend/upnpcdsvideo.h
--- mythtv-0.21/programs/mythbackend/upnpcdsvideo.h	2008-03-02 22:14:41.000000000 +0100
+++ mythtv/programs/mythbackend/upnpcdsvideo.h	2008-03-15 18:53:54.000000000 +0100
@@ -32,6 +32,10 @@
 
     protected:
 
+        virtual UPnpCDSExtensionResults *ProcessItem( UPnpCDSRequest          *pRequest,
+                                                      UPnpCDSExtensionResults *pResults,
+                                                      QStringList             &idPath );
+
         virtual void             CreateItems   ( UPnpCDSRequest          *pRequest,
                                                  UPnpCDSExtensionResults *pResults,
                                                  int                      nNodeIdx,
diff -uNr mythtv-0.21/programs/mythbackend/upnpmedia.cpp mythtv/programs/mythbackend/upnpmedia.cpp
--- mythtv-0.21/programs/mythbackend/upnpmedia.cpp	2008-02-15 00:03:12.000000000 +0100
+++ mythtv/programs/mythbackend/upnpmedia.cpp	2008-04-05 18:00:16.000000000 +0200
@@ -105,11 +105,8 @@
     int parentid;
     QDir vidDir(directory);
     QString title;
-    // If we can't read it's contents move on
     //VERBOSE(VB_UPNP, QString("buildFileList = %1, rootID = %2, itemID =
     //%3").arg(directory).arg(rootID).arg(itemID));
-    if (!vidDir.isReadable())
-        return itemID;
 
     if (rootID > 0) 
         parentid = rootID;
@@ -117,7 +114,9 @@
         parentid = itemID;
 
     vidDir.setSorting( QDir:: DirsFirst | QDir::Name );
-    const QFileInfoList* List = vidDir.entryInfoList();
+    const QFileInfoList *List = vidDir.entryInfoList();
+    // If we can't read it's contents move on
+    if (!List) return itemID;
     for (QFileInfoListIterator it(*List); it; ++it)
     {
         QFileInfo Info(*it.current());
diff -uNr mythtv-0.21/programs/mythcommflag/main.cpp mythtv/programs/mythcommflag/main.cpp
--- mythtv-0.21/programs/mythcommflag/main.cpp	2007-09-29 04:27:09.000000000 +0200
+++ mythtv/programs/mythcommflag/main.cpp	2009-04-14 19:07:48.000000000 +0200
@@ -59,7 +59,7 @@
     program_info->recstartts = QDateTime::currentDateTime().addSecs( -180 * 60);
     program_info->recendts = QDateTime::currentDateTime().addSecs(-1);
     program_info->isVideo = true;
-    program_info->pathname = filename;
+    program_info->pathname = QFileInfo(filename).absFilePath();
 
     RingBuffer *tmprbuf = new RingBuffer(filename, false);
     if (!tmprbuf)
@@ -681,7 +681,7 @@
                         "Missing or invalid parameters for --chanid option");
                 return COMMFLAG_EXIT_INVALID_CHANID;
             }
-            
+
             chanid += a.argv()[++argpos];
         }
         else if (!strcmp(a.argv()[argpos],"-s") ||
@@ -694,7 +694,7 @@
                         "Missing or invalid parameters for --starttime option");
                 return COMMFLAG_EXIT_INVALID_STARTTIME;
             }
-            
+
             starttime += a.argv()[++argpos];
         }
         else if (!strcmp(a.argv()[argpos],"-f") ||
@@ -740,7 +740,7 @@
                 cerr << "Missing or invalid parameter for --allstart\n";
                 return COMMFLAG_EXIT_INVALID_STARTTIME;
             }
-            
+
             allStart = a.argv()[++argpos];
         }
         else if (!strcmp(a.argv()[argpos], "--allend"))
@@ -751,7 +751,7 @@
                 cerr << "Missing or invalid parameter for --allend\n";
                 return COMMFLAG_EXIT_INVALID_STARTTIME;
             }
-            
+
             allEnd = a.argv()[++argpos];
         }
         else if (!strcmp(a.argv()[argpos], "--quiet"))
@@ -849,8 +849,8 @@
                     cerr << "Invalid or missing argument to "
                             "-O/--override-setting option\n";
                     return BACKEND_EXIT_INVALID_CMDLINE;
-                } 
- 
+                }
+
                 QStringList pairs = QStringList::split(",", tmpArg);
                 for (unsigned int index = 0; index < pairs.size(); ++index)
                 {
@@ -863,7 +863,7 @@
                 }
             }
             else
-            { 
+            {
                 cerr << "Invalid or missing argument to -O/--override-setting "
                         "option\n";
                 return GENERIC_EXIT_INVALID_CMDLINE;
diff -uNr mythtv-0.21/programs/mythfilldatabase/channeldata.cpp mythtv/programs/mythfilldatabase/channeldata.cpp
--- mythtv-0.21/programs/mythfilldatabase/channeldata.cpp	2007-11-12 15:23:13.000000000 +0100
+++ mythtv/programs/mythfilldatabase/channeldata.cpp	2008-07-06 17:41:38.000000000 +0200
@@ -374,17 +374,18 @@
 
                 if ((*i).callsign.isEmpty())
                 {
-                    QStringList words = QStringList::split(" ",
-                                        (*i).name.simplifyWhiteSpace().upper());
+                    QStringList words = QStringList::split(" ",(*i).name.simplifyWhiteSpace().upper());
                     QString callsign = "";
-                    if (words[0].isEmpty())
+                    QString w1 = words.size() > 0 ? words[0] : QString();
+                    QString w2 = words.size() > 1 ? words[1] : QString();
+                    if (w1.isEmpty())
                         callsign = QString::number(chanid);
-                    else if (words[1].isEmpty())
+                    else if (w2.isEmpty())
                         callsign = words[0].left(5);
                     else
                     {
-                        callsign = words[0].left(words[1].length() == 1 ? 4:3);
-                        callsign += words[1].left(5 - callsign.length());
+                        callsign = w1.left(w2.length() == 1 ? 4:3);
+                        callsign += w2.left(5 - callsign.length());
                     }
                     (*i).callsign = callsign;
                 }
diff -uNr mythtv-0.21/programs/mythfilldatabase/filldata.cpp mythtv/programs/mythfilldatabase/filldata.cpp
--- mythtv-0.21/programs/mythfilldatabase/filldata.cpp	2008-01-21 03:57:57.000000000 +0100
+++ mythtv/programs/mythfilldatabase/filldata.cpp	2008-09-17 13:37:04.000000000 +0200
@@ -103,7 +103,7 @@
         logged_in  = source.userid;
         raw_lineup = source.id;
     }
-  
+
     if (ok)
         DataDirectStationUpdate(source, false);
 
@@ -111,7 +111,7 @@
 }
 
 bool FillData::grabDDData(Source source, int poffset,
-                          QDate pdate, int ddSource) 
+                          QDate pdate, int ddSource)
 {
     if (source.dd_dups.empty())
         ddprocessor.SetCacheData(false);
@@ -155,7 +155,7 @@
     if (needtoretrieve)
     {
         VERBOSE(VB_GENERAL, "Retrieving datadirect data.");
-        if (dd_grab_all) 
+        if (dd_grab_all)
         {
             VERBOSE(VB_GENERAL, "Grabbing ALL available data.");
             if (!ddprocessor.GrabAllData())
@@ -315,9 +315,20 @@
 
     QString filename = QString(tempfilename);
 
-    QString home = QDir::homeDirPath();
-    QString configfile = QString("%1/%2.xmltv").arg(MythContext::GetConfDir())
+    QString configfile = gContext->GetSetting(QString("XMLTVConfig.%1")
+                                                .arg(source.name),"");
+
+    if (configfile.isEmpty())
+    {
+
+        VERBOSE(VB_GENERAL, "XMLTVConfig entry in settings table missing, "
+                            "falling back to old behavior");
+        QString home = QDir::homeDirPath();
+        configfile = QString("%1/%2.xmltv").arg(MythContext::GetConfDir())
                                                        .arg(source.name);
+    }
+
+    VERBOSE(VB_GENERAL, QString("XMLTV config file is: %1").arg(configfile));
 
     QString command  = QString("nice %1 --config-file '%2' --output %3")
                             .arg(xmltv_grabber.ascii())
@@ -709,14 +720,14 @@
 
             for (int i = 0; i < grabdays; i++)
             {
-                // We need to check and see if the current date has changed 
+                // We need to check and see if the current date has changed
                 // since we started in this loop.  If it has, we need to adjust
                 // the value of 'i' to compensate for this.
                 if (QDate::currentDate() != qCurrentDate)
                 {
                     QDate newDate = QDate::currentDate();
                     i += (newDate.daysTo(qCurrentDate));
-                    if (i < 0) 
+                    if (i < 0)
                         i = 0;
                     qCurrentDate = newDate;
                 }
@@ -764,7 +775,7 @@
                                "GROUP BY c.chanid;";
 
                     if (query.exec(querystr.arg(i-1).arg(i).arg((*it).id)) &&
-                        query.isActive()) 
+                        query.isActive())
                     {
                         VERBOSE(VB_CHANNEL, QString(
                                 "Checking program counts for day %1").arg(i-1));
@@ -782,7 +793,7 @@
                         }
 
                         if (query.exec(querystr.arg(i).arg(i+1).arg((*it).id))
-                                && query.isActive()) 
+                                && query.isActive())
                         {
                             VERBOSE(VB_CHANNEL, QString("Checking program "
                                                 "counts for day %1").arg(i));
@@ -824,7 +835,7 @@
                             VERBOSE(VB_GENERAL, QString(
                                     "Data refresh needed because no data "
                                     "exists for day @ offset %1 from 8PM - "
-                                    "midnight.").arg(i)); 
+                                    "midnight.").arg(i));
                             download_needed = true;
                         }
                         else if (previousDayCount == 0)
@@ -834,7 +845,7 @@
                                     "exists for day @ offset %1 from 8PM - "
                                     "midnight.  Unable to calculate how much "
                                     "we should have for the current day so "
-                                    "a refresh is being forced.").arg(i-1)); 
+                                    "a refresh is being forced.").arg(i-1));
                             download_needed = true;
                         }
                         else if (currentDayCount < (currentChanCount * 3))
@@ -1019,7 +1030,7 @@
 
                 if (!strncmp(strLine.c_str(), "channel", 7))
                 {
-                    channel = strLine.substr(nSplitPoint, 
+                    channel = strLine.substr(nSplitPoint,
                                              strLine.size()).c_str();
                 }
                 else if (!strncmp(strLine.c_str(), "fine", 4))
